

typedef enum {
    I2C_SUCCESS = 0,
    I2C_TIMEOUT,
    I2C_ERROR,
    I2C_BUS_BUSY,
    I2C_ACK_OK,
    I2C_ACK_NOT_OK,
    I2C_ADD_NOT_EXIST
} I2C_Result;

void I2C__Init (unsigned long F_OSC_hz, unsigned long F_i2c_hz);

I2C_Result I2C__Read_Page     (unsigned char I2c_Address, 
                               unsigned char Mem_Address, 
                               unsigned char * pBuffer, 
                               unsigned char pBufferSize);

I2C_Result I2C__Write_Page    (unsigned char I2c_Address, 
                               unsigned char Mem_Address, 
                               unsigned char * pBuffer, 
                               unsigned char pBufferSize);

I2C_Result I2C__Write_Register(unsigned char I2c_Address, 
                               unsigned char Reg, 
                               unsigned char data);

I2C_Result I2C__Read_FullPage (unsigned char I2c_Address, 
                               unsigned char * Reg_Address,
                               unsigned char Reg_Address_Len,
                               unsigned char * pBuffer, 
                               unsigned char pBufferSize);

/* Functions without using enum type */

unsigned char I2C_Write_Page    (unsigned char I2c_Address, 
                                 unsigned char Mem_Address, 
                                 unsigned char * pBuffer, 
                                 unsigned char pBufferSize);

unsigned char I2C_Read_Page    (unsigned char I2c_Address, 
                                unsigned char Mem_Address, 
                                unsigned char * pBuffer, 
                                unsigned char pBufferSize);